/* dict.c
 */

#include <PalmOS.h>
// [kk-start] 07-08-00
#include <zlib.h>
// #include <PalmCompatibility.h>
// #include <StringMgr.h>
// #include <MemoryMgr.h> 
// [kk-end]

#include "dictrc.h"
#include "dict.h"


/* Global variables */
char DictDBName[dmDBNameLength];
UInt16 ViewPage;
char ViewTitle[64];
// [kk-start] 07-08-00
char buffer[DE_BUFFER_SIZE];
// [kk-end]

GlobalData gd;

UInt32  PilotMain (UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
	UInt16 error = 0;

	switch (cmd)
	{

	case sysAppLaunchCmdNormalLaunch:

		if (( error = StartApplication() ) != 0 ) { // Application start code
			return ( error );
		}

		EventLoop();	// Event loop

		StopApplication();	// Application stop code
		break;

	}
	return ( error );
}

// [kk-start] 07-08-00
Err StartApplication(void)
// [kk-end]
{
	Err err;
	DmSearchStateType dbState;	
	UInt16 cardNo;
	LocalID dbID;
	UInt16 count = 0;

	// [kk-start] 07-08-00
	UInt16 total = 0;
	char txt[]="Decompressing..";
	WinDrawChars(txt,StrLen(txt),45,70);
	// [kk-end]

	/* Count how many databases there are */
	if( DmGetNextDatabaseByTypeCreator( true, &dbState, DictType, DictCreator, false, &cardNo, &dbID ) == 0) {
		do { 
			count++;
		} while( DmGetNextDatabaseByTypeCreator( false, &dbState, DictType, DictCreator, false, &cardNo, &dbID ) == 0);
	}

	if( count == 0 ) {
		/* There are no databases */
		FrmAlert(NoDBForm);
		return 1;
	}

	//init Global Data
	MemSet(&gd,sizeof(GlobalData),0);

	gd.CurrentDB = DmOpenDatabaseByTypeCreator( DictType, DictCreator, dmModeReadWrite );

	// [kk-start] 07-08-00
	if ((gd.StatusDB = DmOpenDatabaseByTypeCreator(DictType,DictStatCreator,dmModeReadWrite))) {
		total = DmNumRecords(gd.StatusDB);
		for (count=0;count<total;count++) DmRemoveRecord(gd.StatusDB, 0);
	}
	else {
		// create/open StatusDB
		if ((err = DmCreateDatabase(0,"Thai Dict-Stat",DictStatCreator,DictType,false)))
			return err;
		gd.StatusDB = DmOpenDatabaseByTypeCreator(DictType,DictStatCreator,dmModeReadWrite);
	}

	gd.de_word_record = gd.de_mean_record = 255;
	// [kk-end]

	gd.word_table = (DictTableInfo*) MemPtrNew(wordTableRows*sizeof(DictTableInfo));

	gd.records_total = DmNumRecords(gd.CurrentDB);

	ReadDatabaseInfo();

	LoadWordRecord(gd.current_word_record);
	gd.word_ptr = gd.word_buf;
	// [kk-start] 08-08-00
	// LoadMeanRecord(gd.current_mean_record);
	// gd.mean_ptr = gd.mean_buf;
	// [kk-end]

	FrmGotoForm(DictMain);

	return 0;
}

void EventLoop(void)
{
	short err;
	int formID;
	FormPtr form;
	EventType event;


	do
	{

		EvtGetEvent(&event, 100);  // Wait for an event,
		// ( There are 100 ticks per second on a normal palm device)

		if (SysHandleEvent(&event)) continue;
		if (MenuHandleEvent((void *)0, &event, &err)) continue;

		if (event.eType == frmLoadEvent)  // If the event was that the form was just loaded,
		{
			formID = event.data.frmLoad.formID;	// Get the Id of the form loaded,
			form = FrmInitForm(formID);			// initialise the form
			FrmSetActiveForm(form);				// make the form active.
			switch (formID)
			{
				case DictMain:
				 FrmSetEventHandler(form, (FormEventHandlerPtr) FormDictMainHandler);
				 // Set further events to be handled by our own function, FormHandler
				break;

				case MeanView:
				 FrmSetEventHandler(form, (FormEventHandlerPtr) FormMeanViewHandler);
				 // Set further events to be handled by our own function, FormHandler
				break;
			}
		}
		FrmDispatchEvent(&event); // Deal with the event, whatever it was.

	} while(event.eType != appStopEvent);
	// If someone presses a hardware button, that will run another app, but will
	// signal this app (dict) to Stop ( with AppStopEvent ).


}

void StopApplication(void)
{
	/* ListPreferences listPreferences; */

	/* Remember the state of the application for the next startup */
	/* PrefGetAppPreferencesV10( ListType, ListVersion, &listPreferences, sizeof(ListPreferences));
	StrCopy( listPreferences.lastDBName, ListDBName );
	PrefSetAppPreferencesV10( ListType, ListVersion, &listPreferences, sizeof( ListPreferences )); */

	/* Send a frmSave event to all open forms */
	FrmSaveAllForms();

	/* Close all the open forms */
	FrmCloseAllForms();

	/* Close the database */
	CloseDatabase();
}

Boolean FormDictMainHandler(EventPtr event)
{
	FormPtr  form = FrmGetActiveForm();
	int  handled = 0;
	TablePtr  table;
	FieldPtr  field;	
	UInt16 i;
	// [kk-start] 07-08-00
	ControlPtr ctl=NULL;

	//Boolean endloop;
	//int linecount;
	//char *data;
	// [kk-end]

	switch (event->eType)   // Find out what sort of event it was.
	{
	case frmOpenEvent:

		/* Initialize the word list table */
		table = FrmGetObjectPtr( form, FrmGetObjectIndex( form, WordTable ));
		for( i = 0; i < wordTableRows; i++ ) {
			TblSetItemStyle( table, i, 0, customTableItem );
			TblSetRowUsable( table, i, false );
		}

		TblSetColumnUsable( table, 0, true );

		/* Set the callback routine that will draw the records */
		TblSetCustomDrawProcedure(table, 0, (TableDrawItemFuncPtr) &WordTableDrawRecord );

		i = LoadWordTable();

		FrmDrawForm( form );

		if( i != -1 ) {
			TblSelectItem( table, i, 0 );	
		}

		/* Give the quick lookup text the focus */
		FrmSetFocus( form, FrmGetObjectIndex( form, InputWord ));
		field = FrmGetObjectPtr( form, FrmGetObjectIndex( form, InputWord ));
		FldGrabFocus( field );

	    handled = 1;
		break;

	case ctlSelectEvent:  // A control button was pressed and released.
		switch (event->data.ctlSelect.controlID)
		{
		case ClearButton:		
			form = FrmGetActiveForm();
			
			field = FrmGetObjectPtr( form, FrmGetObjectIndex( form, InputWord ) );
			i = FldGetTextLength( field );
			FldDelete(field, 0, i);

			handled = 1;
		    break;
		case FindButton:		
			form = FrmGetActiveForm();
			handled = QuickScroll( event );
		    break;
		}
	    break;

	case menuEvent:  // If it was a menu event....
		switch (event->data.menu.itemID)	// Find which menu item it was, and display the right form.
	    {
		case OptionsAbout:
		 	ShowMessageDialog(AboutForm);
			break;
		default:
			FrmAlert(AlertForm);
	    }
		handled = 1;
	    break;

	case ctlRepeatEvent:
		/* Do not set handle = true for repeat events so they will repeat automatically */ 
		form = FrmGetActiveForm();
		table = FrmGetObjectPtr( form, FrmGetObjectIndex( form, WordTable ));
		switch( event->data.ctlRepeat.controlID ) {
			case UpButton:
				/* Scroll Up: Backup either mainTableRows - 1 elements, or as far as we can */
				ctl = FrmGetObjectPtr( form, FrmGetObjectIndex( form, UpButton ));
				if( ctl->attr.visible && CtlEnabled( ctl ) ) {
					gd.current_word_record = gd.word_table[0].word_record_number;
					LoadWordRecord(gd.current_word_record);
					GoBack( wordTableRows, gd.word_table[0].ptr_in_record);
				}
				break;
							
			case DownButton:
				/* Scroll Down: make the top visible record the bottom record currently displayed */
				ctl = FrmGetObjectPtr( form, FrmGetObjectIndex( form, DownButton ));
				if( ctl->attr.visible && CtlEnabled( ctl ) ) {
					gd.current_word_record = gd.word_table[gd.last_idx].word_record_number;
					gd.word_ptr = gd.word_table[gd.last_idx].ptr_in_record;

				}
				break;
		}
		if( ctl->attr.visible && CtlEnabled( ctl ) ) { 
			LoadWordTable();
			TblEraseTable( table );
			TblDrawTable( table );
		}
		break;

	case keyDownEvent: 
		form = FrmGetActiveForm();
		table = FrmGetObjectPtr( form, FrmGetObjectIndex( form, WordTable ));
		ctl = NULL;

		switch( event->data.keyDown.chr ) {
			case pageUpChr:
				/* Scroll Up: Backup either mainTableRows - 1 elements, or as far as we can */
				ctl = FrmGetObjectPtr( form, FrmGetObjectIndex( form, UpButton ));
				if( ctl->attr.visible && CtlEnabled( ctl ) ) {
					gd.current_word_record = gd.word_table[0].word_record_number;
					LoadWordRecord(gd.current_word_record);
					GoBack( wordTableRows, gd.word_table[0].ptr_in_record);
				}
				break;

			case pageDownChr:
				/* Scroll Down: make the top visible record the bottom record currently displayed */
				ctl = FrmGetObjectPtr( form, FrmGetObjectIndex( form, DownButton ));
				if( ctl->attr.visible && CtlEnabled( ctl ) ) {
					gd.current_word_record = gd.word_table[gd.last_idx].word_record_number;
					gd.word_ptr = gd.word_table[gd.last_idx].ptr_in_record;
				}
				break;

			//default:
			//	handled = QuickScroll( event );
		}

		if( ctl && ctl->attr.visible && CtlEnabled( ctl ) ) { 
			LoadWordTable();
			TblEraseTable( table );
			TblDrawTable( table );
		}
		break;

	case tblSelectEvent:
		gd.select_idx = TblGetRowID( event->data.tblSelect.pTable, event->data.tblSelect.row );
		gd.select_word_record = gd.word_table[gd.select_idx].word_record_number;
		gd.select_word_ptr = gd.word_table[gd.select_idx].ptr_in_record;
		FrmGotoForm (MeanView);
		handled = true;
		break;

	case nilEvent:
		//ChangeBitmap();
	    handled = 1;
		break;
	default:
		break;
  }
  return handled;
}


// Show a message, if necessary.
void ShowMessageDialog(UInt16 fid)
{
	FormPtr form;
	form = FrmInitForm(fid);
	if (form)
	{
		FrmDoDialog(form);
		FrmDeleteForm(form);
	}
}

void ReadDatabaseInfo()
{
	LocalID dbID;
	UInt16 cardNo; 
	LocalID appInfoID;
	DictAppInfoType *appInfo;

	/* Read the name from the current database */
	DmOpenDatabaseInfo( gd.CurrentDB, &dbID, NULL, NULL, &cardNo, NULL );
	DmDatabaseInfo( cardNo, dbID, DictDBName, NULL, NULL, NULL, NULL, NULL,
					NULL, &appInfoID, NULL, NULL, NULL );
	appInfo = MemLocalIDToLockedPtr( appInfoID, cardNo );

	gd.start_word_record = 0;
	gd.end_word_record = appInfo->WordRecTotal - 1;
	gd.start_mean_record = appInfo->WordRecTotal;
	gd.end_mean_record = appInfo->WordRecTotal + appInfo->MeanRecTotal - 1;

	gd.current_word_record = gd.start_word_record;
	gd.current_mean_record = gd.start_mean_record;

	MemPtrUnlock( appInfo );
}

/* Close the CurrrentDB and update database specific info (current category) */
void CloseDatabase()
{
	LocalID dbID;
	UInt16 cardNo;
	LocalID appInfoID;
	DictAppInfoType *appInfo;

	DmOpenDatabaseInfo( gd.CurrentDB, &dbID, NULL, NULL, &cardNo, NULL );
	DmDatabaseInfo( cardNo, dbID, NULL, NULL, NULL, NULL, NULL, NULL, 
					NULL, &appInfoID, NULL, NULL, NULL );
	appInfo = MemLocalIDToLockedPtr( appInfoID, cardNo );

	MemPtrUnlock( appInfo );

	// [kk-start] 07-08-00
	DmCloseDatabase(gd.StatusDB);
	// [kk-end]
	DmCloseDatabase( gd.CurrentDB );
	/* Clear cached info */
	MemSet(&gd,sizeof(GlobalData),0);
}

/* This draws the list view of the database entries.  
In the future we will have three(?) different draw policies based
on the database info.  For now we will always use a single draw
policy */
void WordTableDrawRecord(MemPtr table, UInt16 row, UInt16 column, RectanglePtr bounds )
{
	//MemHandle recordHandle;
	//DictDBHeader *record;
	//UInt16 recordNumber;

	//recordNumber = TblGetRowID( table, row );  /* the row ID contains the record # */
	// recordHandle = DmQueryRecord( CurrentDB, recordNumber );

	/* If the DmQueryRecord fails, don't use the pointer */
	//if( recordHandle ) {
		//record = MemHandleLock( recordHandle );
		DictDrawEntry( row, bounds );
		//MemHandleUnlock( recordHandle  ); /*  remember to unlock what we lock down */
	//}
}


/* This routine is used to update the main form table.	It is used when:
- intializing the table
- scrolling

Answers the row to highlight if the current record is shown, if the current
row is not shown it answers -1.
*/
UInt16 LoadWordTable()
{
	// [kk-start] 07-08-00
	// UInt16 recordNumber;
	FormPtr form;
	TablePtr table;
	UInt16 i;
	// Err error;
	// [kk-end]
	UInt16 select;
	UInt16 upIndex, downIndex;
	Boolean scrollUp, scrollDown;

	char *data;
	// [kk-start] 07-08-00
	int tabIndex, sz=0;
	// [kk-end]
	Boolean endloop, wordonly;
	UInt16  first_word_record;

	form = FrmGetActiveForm();
	table = FrmGetObjectPtr( form, FrmGetObjectIndex( form, WordTable ));

	scrollUp = true;
	if ((gd.word_ptr == gd.word_buf) && (gd.current_word_record == gd.start_word_record)) scrollUp = false;

	scrollDown = true;

	data = gd.word_ptr;
	first_word_record = gd.current_word_record;
	
	tabIndex = 0;

	endloop = true;
	wordonly = true;

	MemSet(gd.word_table, wordTableRows*sizeof(DictTableInfo), 0);

	while( endloop ) {
		switch( *data ) {
		case DELIMITER: /* if match '#' */
			gd.word_table[tabIndex].word_record_number = gd.current_word_record;
			gd.word_table[tabIndex].ptr_in_record = data;
			data++;
			sz = 0;
			break;
		case TYPE_DELIMITER: /* if match ':' */
			MemMove(gd.word_table[tabIndex].word,(data-sz),sz);
			wordonly = false;
			data++;
			sz = 0;
			break;
		case ADDR_DELIMITER: /* if match '@' */
			if (wordonly) {
				MemMove(gd.word_table[tabIndex].word,(data-sz),sz);
			} else {
				MemMove(gd.word_table[tabIndex].word_type,(data-sz),sz);
			}
			MemMove(&gd.word_table[tabIndex].mean_record_number,(data+1),1);
			gd.word_table[tabIndex].mean_record_number += gd.start_mean_record;
			MemMove(&gd.word_table[tabIndex].mean_offset,(data+2),2);
			MemMove(&gd.word_table[tabIndex].mean_size,(data+4),2);

			wordonly = true;
			data+=6;
			sz = 0;
			tabIndex++;
			if (tabIndex >= wordTableRows) {
				endloop = false;
			}
			break;
		case '\0':
			if (gd.current_word_record == gd.end_word_record) {
				endloop = false;
				scrollDown = false;
			} else {
				gd.current_word_record++;
				LoadWordRecord(gd.current_word_record);
				data = gd.word_buf;
				wordonly = true;
			}
			break;
		default:
			data++;
			sz++;
		}
	}
	//gd.word_ptr = data;
	gd.current_word_record = first_word_record;
	gd.last_idx = tabIndex-1;

	select = -1;
	/* For every table row, fetch the associated record */
	for( i = 0; i < wordTableRows; i++ ) {
		if (gd.word_table[i].word[0] == 0) {
			/* Make the row non-usable */
			TblSetRowUsable( table, i, false );
		} else {
			/* Make the row usable */
			TblSetRowUsable( table, i, true );
			/* Mark it invalid so it will be redrawn */
			TblMarkRowInvalid( table, i );
			/*	Set the row id to be the record number */
			TblSetRowID( table, i, i );
			if (	(gd.select_word_record == gd.word_table[i].word_record_number) && (gd.select_word_ptr == gd.word_table[i].ptr_in_record)) {
				select = i;
			}
		}
	}

	TblUnhighlightSelection( table );
	
	upIndex = FrmGetObjectIndex( form, UpButton );
	downIndex = FrmGetObjectIndex( form, DownButton );

	FrmUpdateScrollers( form, upIndex, downIndex, scrollUp, scrollDown ); 

	return( select );
}


void DictDrawEntry( UInt16 row, RectanglePtr bounds)
{
	char *string;
	Int16 x;
	UInt32 length;
	Boolean needDots = false;
	Boolean done = false;
	Int16 remaining, newLength;
	UInt16 columnWidth;

	FntSetFont( stdFont );
  
	columnWidth = bounds->extent.x;

	if( gd.word_table[row].word != 0 ) {
		string = gd.word_table[row].word;
	} else {
		string = emptyRecordLabel;
	}

	x = bounds->topLeft.x;
	length = StrLen( string );

	/* Restrict the first field to a maximum of 110 pixels */
	if( FntCharsWidth( string, length ) > 110 ) {
		remaining = 110;
		newLength = length;
		FntCharsInWidth( string, &remaining, &newLength, &needDots );
		length = newLength;
		needDots = true;
	}
	WinDrawChars( string, length, x, bounds->topLeft.y );
  
	/* If We truncated the string at all, put some dots */
	x += FntCharsWidth( string, length );
	if( needDots ) {
		WinDrawChars( "..", 2, x, bounds->topLeft.y );
		x += FntCharsWidth( "..", 2 );
		needDots = false;
	}
  
	done = gd.word_table[row].word_type == 0;
	if( !done ) {    
		/* Calculate the amount of room remaining for the second field.
		This is the minimum X value we can use for the next field */
		remaining = (columnWidth - 4) - x; /* note: fudge factor of 4 pixels */
    
		string = gd.word_table[row].word_type;

		length = StrLen( string );
    
		/* Restrict the second field to the remaining pixel size */
		if((x = FntCharsWidth( string, length )) > remaining ) {
			remaining -= FntCharsWidth( "..", 2 );

			newLength = length;
			FntCharsInWidth( string, &remaining, &newLength, &needDots );
			length = newLength;
			needDots = true;
			x = FntCharsWidth( string, length );
		}
		x = columnWidth - x; 
    
		if( needDots ) {
			x -= FntCharsWidth( "..", 2 );
		}
    
		WinDrawChars( string, length, x, bounds->topLeft.y );
		if( needDots ) {
			x += FntCharsWidth( string, length );
			WinDrawChars( "..", 2, x, bounds->topLeft.y );
		}
	}
}

void LoadWordRecord(int recordNo)
{
	// [kk-start] 07-08-00
	MemHandle rec_handle;
	// [kk-end]

	if ((recordNo >= gd.start_word_record) && (recordNo <= gd.end_word_record))
	{
		// [kk-start] 07-08-00
		decompress_record(recordNo);
		rec_handle = DmQueryRecord(gd.StatusDB, 0);

		// rec_handle = DmQueryRecord(gd.CurrentDB, recordNo);
		// [kk-end]

		gd.word_buf = MemHandleLock(rec_handle);
		gd.word_buf_size = MemHandleSize(rec_handle);
		//gd.current_word_record = recordNo;

		MemHandleUnlock(rec_handle);
	}
}

void LoadMeanRecord(int recordNo)
{
	// [kk-start] 07-08-00
	MemHandle rec_handle;
	// [kk-end]

	if ((recordNo >= gd.start_mean_record) && (recordNo <= gd.end_mean_record))
	{
		// [kk-start] 07-08-00
		decompress_record(recordNo);
		rec_handle = DmQueryRecord(gd.StatusDB, 1);
		// rec_handle = DmQueryRecord(gd.CurrentDB, recordNo);
		// [kk-end]

		gd.mean_buf = MemHandleLock(rec_handle);
		gd.mean_buf_size = MemHandleSize(rec_handle);
		//gd.current_mean_record = recordNo;

		MemHandleUnlock(rec_handle);
	}
}

Boolean QuickScroll( EventPtr event ) {
	// [kk-start] 07-08-00
	// MemHandle recordHandle;
	TablePtr table;
	FormPtr form;
	FieldPtr field;
	UInt16 fieldIndex;
	char *alphaSrc='\0';
	// UInt16 alphaScrollRecNum = 0;
	// Boolean alphaScrollMatch = false;
	char alphaDst[64];
	UInt16 quickTextLength;
	// UInt16 qi, alphaHighlight;
	/* Some random key has been input -- if there exists a record
	in the current category whose first letter in the display
	style (ie: sort order) matches, then scroll such that this
	record is visible (top of the screen?) */
	char *data, *end_data;
	// char *ptr_word;
	Int16 sz=0, comp_res, record_no=0, i, start_record=0;
	Boolean endloop, wordonly;
	RectangleType rp;
	// [kk-end]

	/* Update the quick scroll text line */
	form = FrmGetActiveForm();
	table = FrmGetObjectPtr( form, FrmGetObjectIndex( form, WordTable ));
	fieldIndex = FrmGetObjectIndex( form, InputWord );
	FrmSetFocus( form, fieldIndex );
	field = FrmGetObjectPtr( form, fieldIndex );

	quickTextLength = FldGetTextLength( field );

	/* if the text is of zero length, unhighlight any entry in the table */
	if( quickTextLength == 0 ) {
		TblUnhighlightSelection( table );
		return true;
	}

	if( FldHandleEvent( field, event ) || (event->eType == ctlSelectEvent) ) {
		StrToLower( alphaSrc, FldGetTextPtr( field ) );

		/* compare first word in record */
		comp_res = -1;
		// [kk-start] 08-08-00
		// optimizing the search
		if (alphaSrc[0]-'a'<0) {
			FldDelete(field, 0, quickTextLength);
			return true;
		}
		else {
			// hardwired word lookup
			if (StrCompare(alphaSrc, "canary")<0) record_no=start_record=0;
			else if (StrCompare(alphaSrc, "disingenuous")<0) record_no=start_record=1;
			else if (StrCompare(alphaSrc, "granulate")<0) record_no=start_record=2;
			else if (StrCompare(alphaSrc, "leggings")<0) record_no=start_record=3;
			else if (StrCompare(alphaSrc, "overthrow")<0) record_no=start_record=4;
			else if (StrCompare(alphaSrc, "rest")<0) record_no=start_record=5;
			else if (StrCompare(alphaSrc, "surname")<0) record_no=start_record=6;
			else if (StrCompare(alphaSrc, "voluptuous")<0) record_no=start_record=7;
			else if (StrCompare(alphaSrc, "zygote")<0) record_no=start_record=8;
		}
		// record_no = gd.end_word_record;
		// start_record = gd.start_word_record;

		RctSetRectangle(&rp, 50, 65, 60, 20);
		WinEraseRectangle(&rp, 0);
		WinDrawRectangleFrame(roundFrame, &rp);
		WinDrawChars(" Searching... ",14,55,70);
		// [kk-end]

		while ( (comp_res < 0) && (record_no >=  start_record) ) {

			LoadWordRecord(record_no);
			gd.current_word_record = record_no;
			data = gd.word_buf;
			endloop = true;
			MemSet(alphaDst, 64, 0);

			while( endloop ) {
				switch( *data ) {
				case DELIMITER: /* if match '#' */
					data++;
					if (*data == '-' || *data == '\'') { data++; }
					sz = 0;
					break;
				case TYPE_DELIMITER: /* if match ':' */
					MemMove(alphaDst,(data-sz),sz);
					StrToLower( alphaDst, alphaDst );
					endloop = false;
					break;
				case ADDR_DELIMITER: /* if match '@' */
					MemMove(alphaDst,(data-sz),sz);
					StrToLower( alphaDst, alphaDst );
					endloop = false;
					break;
				default:
					data++;
					sz++;
				}
			}
			comp_res = StrCompare(alphaSrc, alphaDst);
			record_no--;
		}

		if (comp_res != 0 ) { /* not match */
			if (comp_res < 0) {

				i = -1;
				FldDelete(field, 0, quickTextLength);
				gd.word_ptr = gd.word_buf;

			} else {

				/* find word in current record */
				data = gd.word_buf;
				end_data = gd.word_buf+gd.word_buf_size;
				comp_res = 1;
				gd.word_ptr = data;
				while ((*data == DELIMITER) && (comp_res>0))
				{
					endloop = true;
					wordonly = true;
					MemSet(alphaDst, 64, 0);

					while( endloop ) {
						switch( *data ) {
						case DELIMITER: /* if match '#' */
							gd.word_ptr = data;
							data++;
							if (*data == '-' || *data == '\'') { data++; }
							sz = 0;
							break;
						case TYPE_DELIMITER: /* if match ':' */
							MemMove(alphaDst,(data-sz),sz);
							StrToLower( alphaDst, alphaDst );
							wordonly = false;
							data++;
							sz = 0;
							break;
						case ADDR_DELIMITER: /* if match '@' */
							if ( wordonly ) {
								MemMove(alphaDst,(data-sz),sz);
								StrToLower( alphaDst, alphaDst );
							}
							endloop = false;
							data += 6;
							sz = 0;
							break;
						default:
							data++;
							sz++;
						}
					}
					comp_res = StrCompare(alphaSrc, alphaDst);
				}

				if (*data == DELIMITER) {
					i = (wordTableRows+1)/2; /* set found word at center screen */
				} else {
					i = wordTableRows-1;
				}
				GoBack( i, gd.word_ptr);

			}

		} else {

			i = (wordTableRows+1)/2; /* set found word at center screen */
			gd.word_ptr = gd.word_buf;
			GoBack( i, gd.word_ptr);

		}

		gd.select_word_record = gd.current_word_record;
		gd.select_word_ptr = gd.word_ptr;

		LoadWordTable();
		TblEraseTable( table );
		TblDrawTable( table );
		if (i >= 0)
		{
			TblSelectItem( table, i-1, 0 );	
		}

		return true;
	}
	return false;
}

void GoBack(int item, char *start) {
	Boolean endloop;
	int linecount;
	char *data;

	endloop = true;
	linecount = item;
	data = start;
	while( endloop ) {
		if (data == gd.word_buf) {
			if (gd.current_word_record == gd.start_word_record) {
				data = gd.word_buf;
				endloop = false;
			} else {
				linecount--;
				gd.current_word_record--;
				LoadWordRecord(gd.current_word_record);
				data = gd.word_buf+gd.word_buf_size-6;
			}
		} else {
			switch( *data ) {
				case DELIMITER:
					linecount--;
					if (linecount <= 0) {
						endloop = false;
					} else {
						data -= 6;
					}
				break;
				default:
					data--;
			}
		}
	}
	gd.word_ptr = data;
}

// [kk-start] 07-08-00
/******************************************
 *	Decompress record #recno					*
 *	Input:	record number (in CurrentDB)	*
 *	Output:	Status DB at						*
 *				= record #0 (for word)			*
 *			or	= record #1 (for mean)			*
 ******************************************/
Err decompress_record(UInt16 recno) {
	Err err;
	UInt16 index = dmMaxRecordIndex;
	MemHandle rec, drec;
	MemPtr prec, pdrec;
	z_stream ds;
	UInt32 len, count=0, dif=0;
	Boolean swap = false;

	// create/lock a decompress record
	if ((recno >= gd.start_word_record) && (recno <= gd.end_word_record)) {
		// if already loaded, just quit
		if (recno == gd.de_word_record) return 0;
		// delete record if it's already there
		if (gd.de_word_record!=255)
			DmRemoveRecord(gd.StatusDB, 0);
		if (gd.de_mean_record!=255) swap = true;
		gd.de_word_record = recno;
	}
	else {
		// if already loaded, just quit
		if (recno == gd.de_mean_record) return 0;

		// delete record if it's already there
		if (gd.de_mean_record!=255)
			DmRemoveRecord(gd.StatusDB, 1);
		gd.de_mean_record = recno;
	}

	// lock/find len of the record
	rec = DmGetRecord(gd.CurrentDB, recno);
	prec = MemHandleLock(rec);
	len = MemHandleSize(rec);

	drec = DmNewRecord(gd.StatusDB, &index, MAX_RECORD_SIZE);
	pdrec = MemHandleLock(drec);	

	// initial inflate
	ds.zalloc = (alloc_func)0;
	ds.zfree = (free_func)0;
	ds.opaque = (voidpf)0;
	ds.next_in = prec;
	ds.next_out = buffer;
	ds.avail_in = len;
	ds.avail_out = DE_BUFFER_SIZE;
	err = inflateInit(&ds);
	buffer[0]='\0';

	// limit at MAX_SIZE
	while (ds.total_in < len && ds.total_out < MAX_RECORD_SIZE && err != Z_STREAM_END) {
		err = inflate(&ds, Z_NO_FLUSH);
		dif = DE_BUFFER_SIZE - ds.avail_out;
		DmWrite(pdrec, count, buffer, dif);
		count += dif;
		ds.next_out = buffer;
		ds.avail_out = DE_BUFFER_SIZE;
	}

	err = inflateEnd(&ds);

	// Unlock/resize decompress (output) record
	MemHandleUnlock(drec);
	DmReleaseRecord(gd.StatusDB, index, true);
	DmResizeRecord(gd.StatusDB, index, count);
	if (swap) DmMoveRecord(gd.StatusDB, 1, 0);

	// Unlock data record
	MemHandleUnlock(rec);
	DmReleaseRecord(gd.CurrentDB, recno, true);

	return 0;
}
// [kk-end]
