#define DictCreator 'TPdb'    /* creator ID, also used in the makefile */
#define DictType    'DATA'    /* type of database */
#define DictVersion 01        /* version number */
// [kk-start] 07-08-00
#define DictStatCreator 'TPst'	/* creator ID for Status */
#define DE_BUFFER_SIZE	1024	/* decompress buffer size */
#define MAX_RECORD_SIZE	65000	/* Max record size */
// #define MAX_RECORD_SIZE	65505	/* Max record size */
// [kk-end]

#define DELIMITER '#'
#define TYPE_DELIMITER ':'
#define ADDR_DELIMITER '@'

#define ESCAPE '\\'

//#define MAX_RECORD_SIZE   (2 + 64 + 4096)

#define emptyRecordLabel	"-empty-"

typedef struct  {
	UInt16  WordRecTotal;
	UInt16  MeanRecTotal;
	UInt16  lastWordPtr;
	UInt16  lastWordRec;

	Char padding[504]; /* exactly 512 bytes */
} DictAppInfoType;

/* The structure stored as the application preferences */
typedef struct {
  char lastDictName[dmDBNameLength];
} DictPreferences;

/*
DictTableInfo - Ѻ红ŷ ʴ˹Ҩͤ 10 records
	word : Ѿ
	word_type : ҹ, 
	word_record_number : Ѿҡ record ?
	ptr_in_record : ˹觢ͧѷ record
	mean_record_number :  record ?
	mean_offset : ˹觢ͧ record
	mean_size : Ǣͧ (ѡ)
*/

typedef struct
{
	char  word[64];
	char  word_type[64];
	UInt16  word_record_number;
	char  *ptr_in_record;
	char  mean_record_number;
	UInt16  mean_offset;
	UInt16  mean_size;
} DictTableInfo;

typedef struct
{
	DmOpenRef  CurrentDB;
	// [kk-start] 07-08-00
	DmOpenRef  StatusDB;
	// [kk-end]
	
	UInt16  start_word_record;
	UInt16  end_word_record;
	UInt16  start_mean_record;
	UInt16  end_mean_record;
	UInt16  records_total;

	char  *word_ptr;
	char  *word_buf;
	UInt16  word_buf_size;
	UInt16  current_word_record;

	char  *mean_ptr;
	char  *mean_buf;
	UInt16  mean_buf_size;
	UInt16  current_mean_record;

	DictTableInfo  *word_table;

	UInt16  select_word_record;
	char  *select_word_ptr;

	UInt16  select_idx;
	UInt16  last_idx;

	// [kk-start] 07-08-00
	UInt16  de_word_record;	// Decompress word record
	UInt16	de_mean_record; // Decompress mean record
	// [kk-end]

} GlobalData;

/*  Global */
extern char DictDBName[];
extern UInt16 ViewPage;
extern char ViewTitle[];

extern GlobalData gd;

/* Prototypes */
// [kk-start] 07-08-00
Err StartApplication(void);
// [kk-end]
void EventLoop(void);
void StopApplication(void);
Boolean FormDictMainHandler(EventPtr event);
void ShowMessageDialog(UInt16 fid);

void ReadDatabaseInfo();
void CloseDatabase();
void WordTableDrawRecord(MemPtr table, UInt16 row, UInt16 column, RectanglePtr bounds );
UInt16 LoadWordTable();
void DictDrawEntry( UInt16 row, RectanglePtr bounds);
void LoadWordRecord(int recordNo);
void LoadMeanRecord(int recordNo);
Boolean QuickScroll( EventPtr event );
void GoBack(int item, char *start);
Err decompress_record(UInt16 recno);

Boolean FormMeanViewHandler(EventPtr event);
void MeanDrawRecord();
char *MeanDrawChars(char *string, UInt16 *y, UInt16 maxY, Boolean draw);
