/* meanview.c
 */

/* Includes required */
#include <PalmOS.h>

#include "dictrc.h"
#include "dict.h"


Boolean FormMeanViewHandler(EventPtr event)
{
	Boolean handled = false;
	FormPtr form;
	ControlPtr ctl=NULL;
	// UInt16 length;
	// UInt16 x, y;
	// [kk-start] 07-08-00
	RectangleType rect;
	// RectangleType rect = { 0, 16, 160, 128 };
	// Boolean penDown;
	// UInt16 attr;
	// UInt16 category;

	RctSetRectangle(&rect,0,16,160,128);
	// [kk-end]
	switch( event->eType )
	{
	case ctlSelectEvent:
		if( event->data.ctlSelect.controlID == MeanDoneButton ) {
			FrmGotoForm( DictMain );
			handled = true;
		}
		break;

	case ctlRepeatEvent:
	case keyDownEvent: 

		form = FrmGetActiveForm();
		if ( (event->data.keyDown.chr == pageUpChr) ||
		(event->data.ctlRepeat.controlID == MeanUpButton) ) {
			/* Scroll Up: backup one page */
			ctl = FrmGetObjectPtr(form, FrmGetObjectIndex(form, MeanUpButton ));
			if ( ctl->attr.visible && CtlEnabled( ctl ) ) {
				ViewPage--;
			} else {
				/* We are at the top of the record, is there a previous record?
				If so, beep and change to viewing that record */
				//if(!DmSeekRecordInCategory( CurrentDB, &CurrentRecord, 1, dmSeekBackward, CurrentCategory )) {
				/* yes there is, play sound, move to new record */
				//	SndPlaySystemSound( sndInfo );
				//	WinEraseWindow();
				//	goto viewRecord;
				//} 
			}
		}
		if( (event->data.keyDown.chr == pageDownChr) || 
			(event->data.ctlRepeat.controlID == MeanDownButton) ) {
			/* Scroll Down: move forward one page */
			ctl = FrmGetObjectPtr( form, FrmGetObjectIndex( form, MeanDownButton ));
			if( ctl->attr.visible && CtlEnabled( ctl ) ) {
				ViewPage++;
			} else {
				/* We are at the bottom of the record, is there another record?
				If so, beep and change to viewing that record */
				//if(!DmSeekRecordInCategory( CurrentDB, &CurrentRecord, 1, dmSeekForward, CurrentCategory )) {
				/* yes there is, play sound, move to new record */
				//	SndPlaySystemSound( sndInfo );
				//	WinEraseWindow();
				//	goto viewRecord;
				//}
			}
		}
		if( ctl->attr.visible && CtlEnabled( ctl ) ) { 
			WinEraseRectangle( &rect, 0 );
			MeanDrawRecord();
		}
		break;

	case frmOpenEvent:
	/* case frmGotoEvent: */

//viewRecord:
		ViewPage = 0; /* Initialize the view page */
		form = FrmGetActiveForm();

		if ( StrLen(gd.word_table[gd.select_idx].word) <= 20 ) {
			StrCopy( ViewTitle, gd.word_table[gd.select_idx].word );
		} else {
			StrNCopy( ViewTitle, gd.word_table[gd.select_idx].word, 20 );
			//StrCat( ViewTitle, ".." );
		}

		FrmSetTitle( form, ViewTitle );
		FrmDrawForm( form );

		//DmRecordInfo( CurrentDB, gd.records_mean, &attr, NULL, NULL );

		MeanDrawRecord();

		handled = true;
		break;
	// [kk-start] 07-08-00
	default:
		break;
	// [kk-end]
	}

	return( handled );
}

/* Draw the record showing the current page of information */

void MeanDrawRecord()
{
	// [kk-start] 07-08-00
	// MemHandle recordHandle;
	// char *record;
	// [kk-end]
	char *string;
	char *mean;
	UInt16 y;
	FormPtr form;
	UInt16 upIndex, downIndex;
	Boolean scrollUp, scrollDown;
	UInt16 skip;

	//recordHandle = DmQueryRecord( CurrentDB, gd.records_mean );
	//record = MemHandleLock( recordHandle );

	//if (gd.current_mean_record != gd.word_table[gd.select_idx].mean_record_number) {
		LoadMeanRecord(gd.word_table[gd.select_idx].mean_record_number);
	//}

	y = 16;
	string = gd.word_table[gd.select_idx].word;
	FntSetFont( largeFont );
	MeanDrawChars( string, &y, 100, (ViewPage == 0) ); 
  
	FntSetFont( stdFont );

	string = gd.word_table[gd.select_idx].word_type;
	MeanDrawChars( string, &y, 100, (ViewPage == 0) ); 

	scrollDown = false;  

	mean = MemPtrNew(gd.word_table[gd.select_idx].mean_size+1);
	MemSet(mean, gd.word_table[gd.select_idx].mean_size+1, 0);
	MemMove(mean, gd.mean_buf + gd.word_table[gd.select_idx].mean_offset, gd.word_table[gd.select_idx].mean_size);

	string = mean;
    
	if( ViewPage != 0 ) {
		/* Skip one or more pages */

			//string = (char *)record + record->mean;
		for(skip=0; skip < ViewPage; skip++) {
			string = MeanDrawChars( string, &y, 128, false );
			y = 16;
		}
	}
    
	if( MeanDrawChars( string, &y, 128, true ) != NULL ) {
		/* There was more to draw */
		scrollDown = true;
	}
  
	//MemHandleUnlock( recordHandle );

	/* update the up/down buttons so they reflect what is possible */
	scrollUp = !(ViewPage == 0);
	form = FrmGetActiveForm();
	upIndex = FrmGetObjectIndex( form, MeanUpButton );
	downIndex = FrmGetObjectIndex( form, MeanDownButton );
	FrmUpdateScrollers( form, upIndex, downIndex, scrollUp, scrollDown );   
  
}

/* Start drawing the string at the y offset, if the edge of the screen
   is reached, wrap to the next line.  Modify the y position value passed
   in to reflect where the next y position is.  Return a pointer to the
   remaining text if we ran out of room on the page, otherwise return
   NULL.  By setting the boolean draw flag to false this routine can
   be used to skip pages. */
char *MeanDrawChars(char *string, UInt16 *y, UInt16 maxY, Boolean draw)
{
	char *text;
	Int16 length;
	Int16 width;
	int truncate;
	int end;
	Boolean truncated;

	text = string;
	do {
		length = end = StrLen( text );
		width = 160;
		/* Get the OS to tell us how many characters will fit */
		FntCharsInWidth( text, &width, &length, &truncated );
		/* truncated is used only if CR caused the end but it may not be in position
		text[length] if it was preceeded by spaces*/
	  
		/* If we're not using all the text, and its not followed by whitespace,
		then try to word wrap it */
		if(( length != end) &&( text[length] != '\n') && ( text[length] != ' ')) { 
			truncate = length;
			while( (length > 0)  && (text[length] != ' ') ) {
				length --;
			}
			/* No spaces at all? -- Just hard wrap it */ 
			if( length == 0 ) {
				length = truncate;
			}
		} 
		/* display the text if we were asked to*/
		if( draw ) {
			WinDrawChars( text, length, 0, *y );
		}
		/* If the entire string was used text[length] is NULL or not whitespace and
		routine will drop through, otherwise it skips one CR or all trailing
		spaces to next word or past next CR */  
		if (text[length]=='\n') {
			length++;
		} else {
			while( ((text[length] == ' ') || (text[length]== '\t')) && (length != end)) {
				if (text[++length] == '\n') {
					length++;
					break;
				}
			}
		}
		/* Set the new position in the string and on the screen and see if we're
		finished with either*/
		text += length;
		*y += FntCharHeight();
	} while ( (length < end) && (*y < maxY) );
  
	/* Let the caller know where we are in the string if there is more*/
	if( length != end ) {
		return( text );
	}
	return( NULL );
}
